// MyToolBoxWnd.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "VisioDraw.h"
#include "MyToolBoxWnd.h"
#include "resource.h"
#include <io.h>
#include <direct.h>
#include <stdlib.h>
#include "NewOpenPageDlg.h"
#include "StdioFileEx.h"

#pragma warning (disable : 4244)
#pragma warning (disable : 4800)
#pragma warning (disable : 4018)
#pragma warning (disable : 4010)
#pragma warning (disable : 4663)

#if _MSC_VER >= 1300
#include <fstream>
#include <iosfwd>
using namespace std;
#else
#include <fstream.h>
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyToolBoxWnd

CMyToolBoxWnd::CMyToolBoxWnd()
{
}

CMyToolBoxWnd::~CMyToolBoxWnd()
{
}

BEGIN_MESSAGE_MAP(CMyToolBoxWnd, CFOMultiToolBoxWnd)
	//{{AFX_MSG_MAP(CMyToolBoxWnd)
	ON_COMMAND(ID_FO_TOOLBOX_CLOSEFILE, OnFoToolboxClosefile)
	ON_COMMAND(ID_FO_TOOLBOX_LOADFILE, OnFoToolboxLoadfile)
	ON_COMMAND(ID_FO_TOOLBOX_NEWFILE, OnFoToolboxNewfile)
	ON_COMMAND(ID_FO_TOOLBOX_SAVEFILE, OnFoToolboxSavefile)
	ON_COMMAND(ID_FO_TOOLBOX_SAVEASFILE, OnFoToolboxSaveasfile)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyToolBoxWnd diagnostics

#ifdef _DEBUG
void CMyToolBoxWnd::AssertValid() const
{
	CWnd::AssertValid();
}

void CMyToolBoxWnd::Dump(CDumpContext& dc) const
{
	CWnd::Dump(dc);
}
#endif //_DEBUG

BOOL CMyToolBoxWnd::ClosePage()
{
	// TODO: Add your action handler code here

	int nIndex = GetActiveIndex();

	if (nIndex == -1)
	{
		return FALSE;
	}

	int nCount = m_arPages.GetSize();
	if (nCount <= 1)
	{
		return FALSE;
	}

	RemovePage(nIndex);

	gfxData.FreeObjectCache();

	return TRUE;
}

void CMyToolBoxWnd::OpenPage(const CString &strPathName, const CString &strFileName)
{
	// TODO: Add your command handler code here

	CString strName;
	strName.LoadString(IDS_FO_NEW_TOOLBOXPAGE);
	AddPage(strName, TRUE);

	m_pToolBoxWnd->LoadResFile(strPathName);
	CString strCaption = strFileName;
	strCaption = strCaption.Left(strCaption.GetLength() - 4);
	m_pToolBoxWnd->GetCurrentPage()->SetObjectCaption(strCaption);
	if (RecalcLayout())
	{
		Invalidate(TRUE);
	}
}

BOOL CMyToolBoxWnd::FindPage(const CString &strTile)
{
	CFOToolBoxPage *pPage = NULL;
	for (int x = m_arPages.GetSize() - 1; x >= 0; x--)
	{
		pPage = (CFOToolBoxPage *)m_arPages.GetAt(x);
		if (pPage->GetObjectCaption() == strTile)
		{
			return TRUE;
		}
	}

	return FALSE;
}

static BOOL XFSetDir(const TCHAR* pcszDir)
{
#if defined( WIN32 )
	return SetCurrentDirectory(pcszDir);
#else   
	if (pcszDir != NULL && *pcszDir != '\0')
	{
		return _chdrive(_totupper(*pcszDir) - 'A' + 1) == 0 &&
			chdir(pcszDir) == 0;
	}

	return FALSE;
#endif
}

void CMyToolBoxWnd::OnFoToolboxSaveasfile()
{
	// TODO: Add your action handler code here
	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	strPathX += _T("\\Shapes\\");
	XFSetDir(strPathX);

	CString title;
	title.LoadString(IDS_FO_SAVE_FILE_TITLE);

	CString strExtx;
	strExtx.LoadString(IDS_FO_TRSFILE_EXT);
	CFileDialog dlgFile(FALSE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, strExtx, this);
	if (dlgFile.DoModal() == IDOK)
	{
		CString strFile = dlgFile.GetPathName();
		CString strExt = dlgFile.GetFileExt();
		CString strCaption = dlgFile.GetFileName();
		strExt.MakeLower();
		if (strExt == _T("trs"))
		{
			//	strFile += _T(".trs");
			m_pToolBoxWnd->SaveResFile(strFile);
			m_pToolBoxWnd->GetCurrentPage()->SetObjectCaption(strCaption);
			if (RecalcLayout())
			{
				Invalidate(TRUE);
			}
		}
		else if (strExt == _T("svg"))
		{
			m_pToolBoxWnd->GetCurrentPage()->ExportToSvg(strFile);

		}
		else if (strExt.IsEmpty())
		{
			if (dlgFile.m_ofn.nFilterIndex == 1)
			{
				strFile += _T(".trs");
				m_pToolBoxWnd->SaveResFile(strFile);
				m_pToolBoxWnd->GetCurrentPage()->SetObjectCaption(strCaption);
				if (RecalcLayout())
				{
					Invalidate(TRUE);
				}
			}
			else
			{
				strFile += _T(".svg");
				m_pToolBoxWnd->GetCurrentPage()->ExportToSvg(strFile);
			}
		}

	}
}

void CMyToolBoxWnd::GetAllPages(CStringArray &array)
{
	CFOToolBoxPage *pPage = NULL;
	for (int x = m_arPages.GetSize() - 1; x >= 0; x--)
	{
		pPage = (CFOToolBoxPage *)m_arPages.GetAt(x);

		CString str = pPage->GetObjectCaption();
		str.MakeLower();
		str.TrimLeft();
		str.TrimRight();
		array.Add(str);
	}
}



void CMyToolBoxWnd::OnCreateNewPage()
{
	// TODO: Add your command handler code here
	CString strName;
	strName.LoadString(IDS_FO_NEW_TOOLBOXPAGE);
	AddPage(strName, TRUE);
}

BOOL FOPSetDir(const TCHAR* pcszDir)
{
#if defined( WIN32 )
	return SetCurrentDirectory(pcszDir);
#else   
	if (pcszDir != NULL && *pcszDir != '\0')
	{
		return _chdrive(_totupper(*pcszDir) - 'A' + 1) == 0 &&
			chdir(pcszDir) == 0;
	}

	return FALSE;
#endif
}

BOOL FOFileExists(CString strFilePath)
{
	CFileStatus fs;
	return CFile::GetStatus(strFilePath, fs);
}

void CMyToolBoxWnd::OnCreateSavePage()
{
	// TODO: Add your command handler code here
	if (GetToolBoxWnd()->GetCurrentPage()->m_strFileName.IsEmpty())
	{
		CString strPathX = AfxGetApp()->m_pszHelpFilePath;
		strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
		FOPSetDir(strPathX);

		//		CString title;
		//		title.LoadString(IDS_FO_SAVE_FILE_TITLE);

		//		CString strExt;
		//		strExt.LoadString(IDS_FO_TRSFILE_EXT);
		//		CFileDialog dlgFile (FALSE,NULL,NULL,OFN_HIDEREADONLY| OFN_OVERWRITEPROMPT,strExt,this);
		//		if(dlgFile.DoModal() == IDOK)
	fopDoStart0311:
		CFORenameDlg dlg;
		if (dlg.DoModal() == IDOK)
		{
			CString strFile = dlg.m_strCaption;
			CString strExt = strFile.Right(3);
			CString strCaption = strFile;
			CString strSave = strCaption;
			strExt.MakeLower();
			if (strExt != _T("trs"))
			{
				strFile += _T(".trs");
				strSave += _T(".trs");
			}
			else
			{
				strCaption = strCaption.Left(strCaption.GetLength() - 4);
			}

			strFile = strPathX + _T("\\Shapes\\") + strFile;
			if (FOFileExists(strFile))
			{
				goto fopDoStart0311;
			}

			GetToolBoxWnd()->SaveResFile(strFile);
			GetToolBoxWnd()->GetCurrentPage()->SetObjectCaption(strCaption);
			if (RecalcLayout())
			{
				Invalidate(TRUE);
			}

			CStringArray m_Files;

			CString strOtherFile;
			strOtherFile = strPathX + _T("\\Shapes\\index.dat");
			CStdioFile m_File;
			if (m_File.Open(strOtherFile, CFile::modeRead | CFile::typeText))
			{
				CString strTemp;
				int nNumber = 100;
				while (m_File.ReadString(strTemp))
				{
					strTemp.TrimLeft();
					strTemp.TrimRight();
					if (!strTemp.IsEmpty())
					{
						m_Files.Add(strTemp);
					}
				}
				m_File.Close();
			}

			CString strFileName;
			strFileName = strOtherFile;// File name

			CStdioFile fileWriteUnicode;

			if (fileWriteUnicode.Open(strFileName,
				CFile::modeCreate | CFile::modeWrite))
			{
				for (int x = 0; x < m_Files.GetSize(); x++)
				{
					CString str = m_Files.GetAt(x);
					fileWriteUnicode.WriteString(str + _T("\n"));
				}

				CString strCur;
				strCur.Format(_T("%u#%s"), m_Files.GetSize(), strSave);
				fileWriteUnicode.WriteString(strCur + _T("\n"));

				fileWriteUnicode.Close();
			}
		}
	}
	else
	{
		GetToolBoxWnd()->GetCurrentPage()->SetModifyFlag(TRUE);
		GetToolBoxWnd()->SaveFile();
	}


}

CString FOPGetFileName(const CString& strFullPath)
{
	CString strFile = strFullPath;
	int nIndex = strFile.ReverseFind(_T('\\'));
	int nIndex2 = strFile.ReverseFind(_T('/'));
	if (nIndex2 > nIndex)
		nIndex = nIndex2;

	if (nIndex >= 0)
	{
		strFile = strFile.Right(strFile.GetLength() - nIndex - 1);
	}

	return strFile;
}

void CMyToolBoxWnd::OpenPage2(CString strSelectFile)
{
	// TODO: Add your command handler code here

	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	FOPSetDir(strPathX);


	{
		if (!strSelectFile.IsEmpty())
		{
			CString strFile = strSelectFile + _T(".trs");

			CString strSave = strFile;

			CString strOtherFile;
			strOtherFile = strPathX + _T("\\Shapes\\") + strFile;

			m_pToolBoxWnd->LoadResFile(strOtherFile);
			CString strCaption = strFile;
			strCaption = strCaption.Left(strCaption.GetLength() - 4);
			m_pToolBoxWnd->GetCurrentPage()->SetObjectCaption(strCaption);
			gfxData.FreeObjectCache();
			if (RecalcLayout())
			{
				Invalidate(TRUE);
			}

		}
	}
}

void CMyToolBoxWnd::OnRemovePage()
{
	// TODO: Add your command handler code here
	CString strMsg = FOPGetFileName(GetToolBoxWnd()->GetCurrentPage()->m_strFileName);
	strMsg = strMsg.Left(strMsg.GetLength() - 4);
	strMsg += _T("\n\n");
	strMsg += _T("Do you make sure you really need to remove this page?");

	if (GetToolBoxWnd()->GetCurrentPage()->m_strFileName.IsEmpty())
	{
		ClosePage();
	}
	else// if(AfxMessageBox(strMsg,
		//		MB_YESNO|MB_ICONINFORMATION) == IDYES)
	{
		CString strxx = GetToolBoxWnd()->GetCurrentPage()->GetObjectCaption();
		strxx += _T(".trs");
		if (!ClosePage())
			return;

		CString strPathX = AfxGetApp()->m_pszHelpFilePath;
		strPathX = strPathX.Left(strPathX.ReverseFind('\\'));

		CStringArray m_Files;
		CString strOtherFile;
		strOtherFile = strPathX + _T("\\Shapes\\index.dat");
		CStdioFile m_File;
		if (m_File.Open(strOtherFile, CFile::modeRead | CFile::typeText))
		{
			CString strTemp;
			int nNumber = 100;
			while (m_File.ReadString(strTemp))
			{
				strTemp.TrimLeft();
				strTemp.TrimRight();
				if (!strTemp.IsEmpty())
				{
					CString strTitle;
					CString strFile;
					strTitle = strTemp.Left(strTemp.ReverseFind('#'));
					strFile = strTemp.Right(strTemp.GetLength() - strTitle.GetLength() - 1);
					if ((!strTitle.IsEmpty()) && (!strFile.IsEmpty()))
					{
						if (strFile != strxx)
							m_Files.Add(strTemp);
					}
				}
			}
			m_File.Close();
		}

		CString strFileName;
		strFileName = strOtherFile;// File name

		CStdioFile fileWriteUnicode;

		if (fileWriteUnicode.Open(strFileName,
			CFile::modeCreate | CFile::modeWrite))
		{
			for (int x = 0; x < m_Files.GetSize(); x++)
			{
				CString str = m_Files.GetAt(x);
				fileWriteUnicode.WriteString(str + _T("\n"));
			}

			fileWriteUnicode.Close();
		}
	}
}

void CMyToolBoxWnd::DoOpenPage(const CString &strFile)
{

	CString strTile;
	strTile = theApp.XGetFileName(strFile);
	OpenPage(strFile, strTile);

}

void CMyToolBoxWnd::OnOpenPage()
{
	// TODO: Add your command handler code here

	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	FOPSetDir(strPathX);

	CNewOpenPageDlg dlgFile;
	GetAllPages(dlgFile.m_array);
	if (dlgFile.DoModal() == IDOK)
	{
		if (!dlgFile.strSelectFile.IsEmpty())
		{
			CString strFile = dlgFile.strSelectFile + _T(".trs");

			CString strSave = strFile;

			CString strOtherFile;
			strOtherFile = strPathX + _T("\\Shapes\\") + strFile;
			OpenPage(strOtherFile, strFile);

			CString strPathX = AfxGetApp()->m_pszHelpFilePath;
			strPathX = strPathX.Left(strPathX.ReverseFind('\\'));

			{
				CStringArray m_Files;
				CString strOtherFile;
				strOtherFile = strPathX + _T("\\Shapes\\index.dat");
				CStdioFile m_File;
				if (m_File.Open(strOtherFile, CFile::modeRead | CFile::typeText))
				{
					CString strTemp;
					int nNumber = 100;
					while (m_File.ReadString(strTemp))
					{
						strTemp.TrimLeft();
						strTemp.TrimRight();
						if (!strTemp.IsEmpty())
						{
							CString strTitle;
							CString strFile;
							strTitle = strTemp.Left(strTemp.ReverseFind('#'));
							strFile = strTemp.Right(strTemp.GetLength() - strTitle.GetLength() - 1);
							if ((!strTitle.IsEmpty()) && (!strFile.IsEmpty()))
							{
								m_Files.Add(strTemp);
							}
						}
					}
					m_File.Close();
				}

				CString strFileName;
				strFileName = strOtherFile;// File name

				CStdioFile fileWriteUnicode;

				if (fileWriteUnicode.Open(strFileName,
					CFile::modeCreate | CFile::modeWrite))
				{
					for (int x = 0; x < m_Files.GetSize(); x++)
					{
						CString str = m_Files.GetAt(x);
						fileWriteUnicode.WriteString(str + _T("\n"));
					}

					CString strCur;
					strCur.Format(_T("%u#%s"), m_Files.GetSize(), strSave);
					fileWriteUnicode.WriteString(strCur + _T("\n"));

					fileWriteUnicode.Close();
				}
			}
		}
	}
}

void CMyToolBoxWnd::OnFoToolboxClosefile()
{
	// TODO: Add your action handler code here
	OnRemovePage();
}

void CMyToolBoxWnd::OnFoToolboxLoadfile()
{
	// TODO: Add your action handler code here
	OnOpenPage();
}

void CMyToolBoxWnd::OnFoToolboxNewfile()
{
	// TODO: Add your action handler code here
	OnCreateNewPage();
}

void CMyToolBoxWnd::OnFoToolboxSavefile()
{
	// TODO: Add your action handler code here
	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	strPathX += _T("\\Shapes\\");
	XFSetDir(strPathX);

	OnCreateSavePage();
}

void CMyToolBoxWnd::DoCreateToolBoxPageWnd()
{
	m_pToolBoxWnd = new CMyToolBoxPageWnd;
}

/////////////////////////////////////////////////////////////////////////////
// CMyToolBoxPageWnd

CMyToolBoxPageWnd::CMyToolBoxPageWnd()
{
}

CMyToolBoxPageWnd::~CMyToolBoxPageWnd()
{
}

BEGIN_MESSAGE_MAP(CMyToolBoxPageWnd, CFOToolBoxPageWnd)
	//{{AFX_MSG_MAP(CMyToolBoxPageWnd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CMyToolBoxPageWnd::DoSaveResFile()
{
	if (GetCurrentPage()->m_strFileName.IsEmpty())
	{
		CString strPathX = AfxGetApp()->m_pszHelpFilePath;
		strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
		FOPSetDir(strPathX);

		//		CString title;
		//		title.LoadString(IDS_FO_SAVE_FILE_TITLE);

		//		CString strExt;
		//		strExt.LoadString(IDS_FO_TRSFILE_EXT);
		//		CFileDialog dlgFile (FALSE,NULL,NULL,OFN_HIDEREADONLY| OFN_OVERWRITEPROMPT,strExt,this);
		//		if(dlgFile.DoModal() == IDOK)
	fopDoStart0311:
		CFORenameDlg dlg;
		if (dlg.DoModal() == IDOK)
		{
			CString strFile = dlg.m_strCaption;
			CString strExt = strFile.Right(3);
			CString strCaption = strFile;
			CString strSave = strCaption;
			strExt.MakeLower();
			if (strExt != _T("trs"))
			{
				strFile += _T(".trs");
				strSave += _T(".trs");
			}
			else
			{
				strCaption = strCaption.Left(strCaption.GetLength() - 4);
			}

			strFile = strPathX + _T("\\Shapes\\") + strFile;
			if (FOFileExists(strFile))
			{
				goto fopDoStart0311;
			}

			SaveResFile(strFile);
			GetCurrentPage()->SetObjectCaption(strCaption);
			//			if( RecalcLayout())
			{
				Invalidate(TRUE);
			}

			CStringArray m_Files;

			CString strOtherFile;
			strOtherFile = strPathX + _T("\\Shapes\\index.dat");
			CStdioFile m_File;
			if (m_File.Open(strOtherFile, CFile::modeRead | CFile::typeText))
			{
				CString strTemp;
				int nNumber = 100;
				while (m_File.ReadString(strTemp))
				{
					strTemp.TrimLeft();
					strTemp.TrimRight();
					if (!strTemp.IsEmpty())
					{
						m_Files.Add(strTemp);
					}
				}
				m_File.Close();
			}

			CString strFileName;
			strFileName = strOtherFile;// File name

			CStdioFile fileWriteUnicode;

			if (fileWriteUnicode.Open(strFileName,
				CFile::modeCreate | CFile::modeWrite))
			{
				for (int x = 0; x < m_Files.GetSize(); x++)
				{
					CString str = m_Files.GetAt(x);
					fileWriteUnicode.WriteString(str + _T("\n"));
				}

				CString strCur;
				strCur.Format(_T("%u#%s"), m_Files.GetSize(), strSave);
				fileWriteUnicode.WriteString(strCur + _T("\n"));

				fileWriteUnicode.Close();
			}

		}
	}
	else
	{
		GetCurrentPage()->SetModifyFlag(TRUE);
		SaveFile();
	}

	return TRUE;
}
