// UCCShapePropDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VisioDraw.h"
#include "UCCShapePropDlg.h"
#include "VisioDrawDoc.h"
#include "VisioDrawView.h"
#include "FOFillEffectDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUCCShapePropDlg dialog


CUCCShapePropDlg::CUCCShapePropDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUCCShapePropDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUCCShapePropDlg)
 
	m_nTrans = 0;
 
	//}}AFX_DATA_INIT
	 
	m_crBK = RGB(255,255,255);
	m_crFG = RGB(255,255,255);
	pOldSelect = NULL;
	nOldSelectCount = 0;
	m_bSelect = FALSE;
	m_bDragging=FALSE;
 
}


void CUCCShapePropDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUCCShapePropDlg)
	 
	DDX_Control(pDX, IDC_BUTTON_GRADIENT, m_btnGradient);
	
	DDX_Control(pDX, IDC_SLIDER_TRANS, m_sliderTrans);
	 
	DDX_Slider(pDX, IDC_SLIDER_TRANS, m_nTrans);
	 
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COMBO_FONTFACE, m_FontFaceName);
	DDX_Control(pDX, IDC_COMBO_FONTSIZE, m_cbSize);
	DDX_Control(pDX, IDC_BUTTON_FONTCOLOR, m_btnTextColor);
	DDX_ColorDropDown(pDX, IDC_BUTTON_FONTCOLOR, crText);
 
	DDX_Control(pDX, IDC_BUTTON_START, m_wndBKColor);
	DDX_ColorDropDown(pDX, IDC_BUTTON_START, m_crBK);
	DDX_Control(pDX, IDC_BUTTON_END, m_wndFGColor);
	DDX_ColorDropDown(pDX, IDC_BUTTON_END, m_crFG);
 

}


BEGIN_MESSAGE_MAP(CUCCShapePropDlg, CDialog)
	//{{AFX_MSG_MAP(CUCCShapePropDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_FONTFACE, OnSelchangeComboFontface)
	ON_CBN_SELCHANGE(IDC_COMBO_FONTSIZE, OnSelchangeComboFontsize)
	ON_WM_VSCROLL()
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_TRANS, OnReleasedcaptureSliderTrans)
  
	ON_BN_CLICKED(IDC_BUTTON_GRADIENT, OnButtonGradient)
	ON_WM_HSCROLL()
	
	ON_CBN_EDITCHANGE(IDC_COMBO_FONTSIZE, OnEditchangeComboFontsize)
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KILLFOCUS()
	ON_WM_SETCURSOR()

	ON_CONTROL(FOP_MSG__COLOR_CHANGE, IDC_BUTTON_FONTCOLOR,	OnTextColourChange)
 
	ON_CONTROL(FOP_MSG__COLOR_CHANGE, IDC_BUTTON_START,	OnStartColourChange)
	ON_CONTROL(FOP_MSG__COLOR_CHANGE, IDC_BUTTON_END,	OnEndColourChange)
 
	ON_MESSAGE(WM_FO_SELECTBRUSHTYPEOK, OnFillOK)
	ON_MESSAGE(WM_FO_SELECTGRADIENTTYPEOK, OnFillOK2)
	ON_MESSAGE(WM_FO_SELECTIMAGETYPEOK, OnFillOK3)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUCCShapePropDlg message handlers

BOOL CUCCShapePropDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_FontFaceName.SelectString(-1,_T("Arial"));
	 
	m_sliderTrans.SetRange(0, 255, FALSE);
	m_sliderTrans.SetTicFreq(10);
	m_sliderTrans.SetPos(m_nTrans);
	GetDlgItem(IDC_STATIC_FILL)->SetFont(&gfxData.fontBold);
 
	GetDlgItem(IDC_STATIC_TEXT)->SetFont(&gfxData.fontBold);
 
	InitFontSize();
	m_hCursor1=AfxGetApp()->LoadCursor(IDC_FO_HAND);
	m_hCursor2=AfxGetApp()->LoadCursor(IDC_FO_HAND);
	
	//SetClassLong(m_hWnd,GCL_HCURSOR,(long)m_hCursor1);
	
	// save the original size
	GetWindowRect(m_rcOriginalRect);
	
	// initial scroll position
	m_nScrollPos = 0; 

// 
// 	SCROLLINFO vinfo;
// 	vinfo.cbSize=sizeof(vinfo);
// 	vinfo.fMask=SIF_ALL;
// 	vinfo.nPage=50;
// 	vinfo.nMax=400;//ֵܹ
// 	vinfo.nMin=0;//ܹСֵ
// 	vinfo.nTrackPos=0;
// 	SetScrollInfo(SB_VERT,&vinfo);//ʹһʹôҲʾ
 

	CRect rectListWnd;
	GetDlgItem(IDC_TAB)->GetWindowRect(rectListWnd);
	ScreenToClient(rectListWnd);
	
 
	DWORD dwStyle = WS_CHILD | WS_VISIBLE | FOP_TS_ALIGN_TOP | WS_TABSTOP;
	m_wndTabs.Create(this, dwStyle);
	m_wndTabs.SetWindowPos(&wndTop,rectListWnd.left,rectListWnd.top,rectListWnd.Width(),rectListWnd.Height(),SWP_SHOWWINDOW);

	
	m_wndPattern.Create(WS_CHILD|WS_VISIBLE|WS_EX_CLIENTEDGE,rectListWnd,&m_wndTabs,IDC_FO_PATTERN,m_nBrushType);
	m_wndPattern.GetBrushControl()->SetBorderType(BORDER_NONE);
	m_wndPattern.GetBrushControl()->SetBKColor(m_crBK);
	m_wndPattern.GetBrushControl()->SetFGColor(m_crFG);
	m_wndPattern.GetBrushControl()->SetBrushType(m_nBrushType);

	m_wndGradient.Create(WS_CHILD|WS_VISIBLE|WS_EX_CLIENTEDGE,rectListWnd,&m_wndTabs,IDC_FO_GRADIENT,m_nBrushType);
	m_wndGradient.GetGradientControl()->SetBorderType(BORDER_NONE);
	m_wndGradient.SetBKColor(m_crBK);
	m_wndGradient.SetFGColor(m_crFG);
//	m_wndGradient.m_bIsAxisUp = m_bIsAxisUp;
	m_wndGradient.GetGradientControl()->SetGradientType(m_nBrushType);
	

	m_wndImage.Create(WS_CHILD|WS_VISIBLE|WS_EX_CLIENTEDGE,rectListWnd,&m_wndTabs,IDC_FO_TEXTTURE,m_nBrushType);
	m_wndImage.GetImageTypeControl()->SetBorderType(BORDER_NONE);
	m_wndImage.GetImageTypeControl()->SetImageType(m_nBrushType);


//	m_wndTabs.SetImageAutoScale();
	m_wndTabs.AddTab(&m_wndPattern, _T("Hatch"));
	m_wndTabs.AddTab(&m_wndGradient, _T("Gradient"));
	m_wndTabs.AddTab(&m_wndImage, _T("Image"));

	m_wndTabs.ActivateTab(2);
	m_wndTabs.ActivateTab(1);
	m_wndTabs.ActivateTab(0);
 
	m_wndTabs.SetDrawFlatBorder(TRUE);
 
	m_wndTabs.GetTabControl()->SetActiveTabBkColor(RGB(254,254,254));
	m_wndTabs.GetTabControl()->SetInActiveTabBkColor(RGB(240,240,240));
	m_wndTabs.UpdateWindow();

	m_wndPattern.SetNofityWnd(this);
	m_wndGradient.SetNofityWnd(this);
	m_wndImage.SetNofityWnd(this);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CUCCShapePropDlg::InitFontSize()
{
	CComboBox *pBox = (CComboBox *)GetDlgItem(IDC_COMBO_FONTSIZE);
	// Clear the combobox.
	pBox->ResetContent();
	TCHAR buf[10];
	for (int i = 0; i < 25; i++)
	{
		wsprintf(buf, _T("%d"), nFO_FontDefSizes[i]);
		pBox->AddString(buf);
	}
	
	pBox->SetCurSel(4);
}

BOOL FOIsAllDigitsX66(LPCTSTR lpStr)
{
	while (*lpStr != '\0')
	{
		if (!_istdigit(*lpStr++))
		{
			return FALSE;
		}
	}
	return TRUE;
}

void CUCCShapePropDlg::GetAllSelShapes(CFODrawShapeList &mList)
{
	CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return;
	
 
	CFODrawShapeList* pShapeList = pViewTemp->GetSelectShapes();
	if(pShapeList->GetCount() < 1)
			return;

	CFODrawShape *pReturn = NULL;
	POSITION pos = pShapeList->GetHeadPosition();
	while(pos != NULL)
	{
		pReturn = (CFODrawShape *)pShapeList->GetNext(pos);
		
		if(pReturn->IsKindOf(RUNTIME_CLASS(CFOCompositeShape)))
		{
			CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pReturn);
			pComp->GetAllShapesInDepth(mList);
		}
		else
		{
			
			mList.AddTail(pReturn);
		}
	}
}
 

void CUCCShapePropDlg::OnSelchangeComboFontface() 
{
	// TODO: Add your control notification handler code here
	if(m_bSelect)
		return;

	CString strText;
	int nCur = m_FontFaceName.GetCurSel();
	if(nCur >= 0)
	{
		m_FontFaceName.GetLBText(nCur,strText);

		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;
	 
		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		 
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
		{
			if(!m_bSelect)
			{
				CString strText;
				m_cbSize.GetWindowText(strText);
			
				if(!strText.IsEmpty())
				{
					if(FOIsAllDigitsX66(strText))
					{
						int nSize = _ttoi(strText);
						((CExtTabModel *)pModel)->maCurStyle.SetPointSize(nSize);
					}
				}

				crText = m_btnTextColor.GetColor();
				((CExtTabModel *)pModel)->maCurStyle.SetFaceName(strText);
				
				((CExtTabModel *)pModel)->maCurStyle.SetFontColor(crText);
			}
			return;
		}

		if(maList.GetCount() == 1)
		{
			CFODrawShape *pCur = (CFODrawShape *)maList.GetHead();
			if(pCur != NULL)
			{
				if(HAS_BASE(pCur, FOXNewTableShape))
				{
					FOXNewTableShape *pTable = (FOXNewTableShape *)(pCur);
					if(pTable != NULL)
					{
						CFOPNewTableCellList m_SelectList;
						pTable->GetSelectCells(&m_SelectList);
						
						if(m_SelectList.GetCount() >0)
						{
							CFOPSdrTableGeoAction* pAction = new CFOPSdrTableGeoAction(pModel,pTable);
							CRect rcUpdate = pTable->GetBoundRect();
							rcUpdate.bottom += 22;
							pAction->SetSaveUpdateRect(rcUpdate);
							
							POSITION pos = m_SelectList.GetHeadPosition();
							while(pos != NULL)
							{
								CFOPNewTableCell *cellX = (CFOPNewTableCell*)m_SelectList.GetNext(pos);
								if(cellX == 0) 
									continue;
								
								cellX->SetFaceName(strText);
							 
							}
							//	pTable->UpdateComp();
							//	InvalidateShape(pTable);
							pAction->pNewGeo = pTable->GetTableKeyData();
							if(!pModel->Do(pAction))
							{
								delete pAction;
								}

							return;
						}
					}
				}
			}
		}
		
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		pAction->AddShapesString(maList,strText, P_ID_FONT_FACENAME);
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
	 
	}
}
 

void CUCCShapePropDlg::OnTextColourChange()
{
	// We receive this on a color change from one of the well buttons
	if(m_bSelect)
		return;

	crText = m_btnTextColor.GetColor();
	
    CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return;
	
	CFODataModel* pModel = pViewTemp->GetCurrentModel();
	if(NULL == pModel)
		return;
	
	 
	CFODrawShapeList maList;
	GetAllSelShapes(maList);

	if(maList.GetCount() == 1)
				{
		CFODrawShape *pCur = (CFODrawShape *)maList.GetHead();
		if(pCur != NULL)
		{
			if(HAS_BASE(pCur, FOXNewTableShape))
			{
				FOXNewTableShape *pTable = (FOXNewTableShape *)(pCur);
				if(pTable != NULL)
				{
					CFOPNewTableCellList m_SelectList;
					pTable->GetSelectCells(&m_SelectList);
					
					if(m_SelectList.GetCount() >0)
					{
						CFOPSdrTableGeoAction* pAction = new CFOPSdrTableGeoAction(pModel,pTable);
						CRect rcUpdate = pTable->GetBoundRect();
						rcUpdate.bottom += 22;
						pAction->SetSaveUpdateRect(rcUpdate);
						
						POSITION pos = m_SelectList.GetHeadPosition();
						while(pos != NULL)
						{
							CFOPNewTableCell *cellX = (CFOPNewTableCell*)m_SelectList.GetNext(pos);
							if(cellX == 0) 
								continue;
							
							cellX->SetFontColor(crText);
							
						}
						//	pTable->UpdateComp();
						//	InvalidateShape(pTable);
						pAction->pNewGeo = pTable->GetTableKeyData();
						if(!pModel->Do(pAction))
						{
							delete pAction;
						}
						
						return;
					}
				}
			}
		}
	}
		

	if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
	{
		if(!m_bSelect)
		{
			CString strText;
			
			m_cbSize.GetWindowText(strText);
		
			if(!strText.IsEmpty())
			{
				if(FOIsAllDigitsX66(strText))
				{
					int nSize = _ttoi(strText);
					((CExtTabModel *)pModel)->maCurStyle.SetPointSize(nSize);
				}
			}
			
			crText = m_btnTextColor.GetColor();
			((CExtTabModel *)pModel)->maCurStyle.SetFaceName(strText);
			
			((CExtTabModel *)pModel)->maCurStyle.SetFontColor(crText);
		}
		return;
	}
		
	
	CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
	CRect rc = pViewTemp->GetTotalSelectSnapRect();
	pAction->AddShapesColor(maList,crText, P_ID_FONT_COLOR);
	if(pAction->GetActionList()->GetCount() > 0)
	{
		pModel->Do(pAction, TRUE);
		pModel->SetModifiedFlag();
	}
	else
	{
		delete pAction;
	}
 
}
 
void CUCCShapePropDlg::OnSelchangeComboFontsize() 
{
	// TODO: Add your control notification handler code here
	if(m_bSelect)
		return;

	CString strText;
	int nCur = m_cbSize.GetCurSel();
	if(nCur >= 0)
	{
		m_cbSize.GetLBText(nCur,strText);
	}
	
	if(!strText.IsEmpty())
	{
		if(FOIsAllDigitsX66(strText))
		{
			int nSize = _ttoi(strText);
			if(nSize >= 0 && nSize <= 1000)
			{
				CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
				if(NULL == pViewTemp)
					return;
				
				CFODataModel* pModel = pViewTemp->GetCurrentModel();
				if(NULL == pModel)
					return;
				
				 
				CFODrawShapeList maList;
				GetAllSelShapes(maList);

				if(maList.GetCount() == 1)
				{
					CFODrawShape *pCur = (CFODrawShape *)maList.GetHead();
					if(pCur != NULL)
					{
						if(HAS_BASE(pCur, FOXNewTableShape))
						{
							FOXNewTableShape *pTable = (FOXNewTableShape *)(pCur);
							if(pTable != NULL)
							{
								CFOPNewTableCellList m_SelectList;
								pTable->GetSelectCells(&m_SelectList);
								
								if(m_SelectList.GetCount() >0)
								{
									CFOPSdrTableGeoAction* pAction = new CFOPSdrTableGeoAction(pModel,pTable);
									CRect rcUpdate = pTable->GetBoundRect();
									rcUpdate.bottom += 22;
									pAction->SetSaveUpdateRect(rcUpdate);
									
									POSITION pos = m_SelectList.GetHeadPosition();
									while(pos != NULL)
									{
										CFOPNewTableCell *cellX = (CFOPNewTableCell*)m_SelectList.GetNext(pos);
										if(cellX == 0) 
											continue;
										
										cellX->SetPointSize(nSize);
										
									}
									//	pTable->UpdateComp();
									//	InvalidateShape(pTable);
									pAction->pNewGeo = pTable->GetTableKeyData();
									if(!pModel->Do(pAction))
									{
										delete pAction;
									}
									
									return;
								}
							}
						}
					}
				}
		
				if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
				{
					if(!m_bSelect)
					{
					 
						if(!strText.IsEmpty())
						{
							if(FOIsAllDigitsX66(strText))
							{
								int nSize = _ttoi(strText);
								((CExtTabModel *)pModel)->maCurStyle.SetPointSize(nSize);
							}
						}
						
						crText = m_btnTextColor.GetColor();
						((CExtTabModel *)pModel)->maCurStyle.SetFaceName(strText);
						
						((CExtTabModel *)pModel)->maCurStyle.SetFontColor(crText);
					}
					return;
				}
		
				
				CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
				CRect rc = pViewTemp->GetTotalSelectSnapRect();
				pAction->AddShapesInt(maList,nSize, P_ID_FONT_POINTSIZE);
				if(pAction->GetActionList()->GetCount() > 0)
				{
					pModel->Do(pAction, TRUE);
					pModel->SetModifiedFlag();
				}
				else
				{
					delete pAction;
				}

				POSITION pos = maList.GetHeadPosition();
				while(pos != NULL)
				{
					CFODrawShape *pCur = (CFODrawShape *)maList.GetNext(pos);
					pCur->AdjustTextBoxSize(NULL);
					pCur->UpdateControl();
				}
 
			}
		}
	}
}

void CUCCShapePropDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default

	if(HAS_BASE(pScrollBar, CSpinButtonCtrl))
	{
		CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
		return;
	}
	int nDelta;
	int nMaxPos = m_rcOriginalRect.Height() - m_nCurHeight;
	
	switch (nSBCode)
	{
	case SB_LINEDOWN:
		if (m_nScrollPos >= nMaxPos)
			return;
		
		nDelta = min(max(nMaxPos/20,5),nMaxPos-m_nScrollPos);
		break;
		
	case SB_LINEUP:
		if (m_nScrollPos <= 0)
			return;
		nDelta = -min(max(nMaxPos/20,5),m_nScrollPos);
		break;
	case SB_PAGEDOWN:
		if (m_nScrollPos >= nMaxPos)
			return;
		nDelta = min(max(nMaxPos/10,5),nMaxPos-m_nScrollPos);
		break;
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		nDelta = (int)nPos - m_nScrollPos;
		break;
		
	case SB_PAGEUP:
		if (m_nScrollPos <= 0)
			return;
		nDelta = -min(max(nMaxPos/10,5),m_nScrollPos);
		break;
		
	default:
		return;
	}
	m_nScrollPos += nDelta;
	SetScrollPos(SB_VERT,m_nScrollPos,TRUE);
	ScrollWindow(0,-nDelta);
	 
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CUCCShapePropDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_bDragging=TRUE;
	SetCapture();
	
	m_ptDragPoint=point;
	
	SetCursor(m_hCursor2);
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CUCCShapePropDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	EndDrag();
	
	CDialog::OnLButtonUp(nFlags, point);
}

void CUCCShapePropDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_bDragging)
	{
		int nDelta=m_ptDragPoint.y-point.y;
		m_ptDragPoint=point;
		
		int nNewPos=m_nScrollPos+nDelta;
		
		if (nNewPos<0)
			nNewPos=0;
		else if (nNewPos>m_rcOriginalRect.Height() - m_nCurHeight)
			nNewPos=m_rcOriginalRect.Height() - m_nCurHeight;
		
		nDelta=nNewPos-m_nScrollPos;
		m_nScrollPos=nNewPos;
		
		SetScrollPos(SB_VERT,m_nScrollPos,TRUE);
		ScrollWindow(0,-nDelta);
	}
	
	CDialog::OnMouseMove(nFlags, point);
}

void CUCCShapePropDlg::OnKillFocus(CWnd* pNewWnd) 
{
	CDialog::OnKillFocus(pNewWnd);
	
	EndDrag();
}

void CUCCShapePropDlg::EndDrag()
{
	m_bDragging=FALSE;
	ReleaseCapture();
	SetCursor(m_hCursor1);
}

BOOL CUCCShapePropDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	BOOL bRet=TRUE;
	
	if (nHitTest==HTCLIENT)
	{
		SetCursor(m_hCursor1);
		bRet=FALSE;
	}
	else
		bRet=CDialog::OnSetCursor(pWnd,nHitTest,message);
	
	return bRet;
}

void CUCCShapePropDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	m_nCurHeight = cy;
	
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL; 
	si.nMin = 0;
	si.nMax = m_rcOriginalRect.Height();
	si.nPage = cy;
	si.nPos = 0;
    SetScrollInfo(SB_VERT, &si, TRUE); 	
	
}
 
void CUCCShapePropDlg::OnStartColourChange()
{
	// We receive this on a color change from one of the well buttons
	if(m_bSelect)
		return;

	COLORREF crOldBK = m_crBK;
	COLORREF crOldFG = m_crFG;
	m_crBK = m_wndBKColor.GetColor();
	m_crFG = m_wndFGColor.GetColor();
	m_wndPattern.SetFGColor(m_crFG);
	m_wndPattern.SetBKColor(m_crBK);
	m_wndGradient.SetFGColor(m_crFG);
	m_wndGradient.SetBKColor(m_crBK);
	 
		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;
		
		
		CFODrawShapeList maList;
		GetAllSelShapes(maList);

		if(maList.GetCount() == 1)
		{
			CFODrawShape *pCur = (CFODrawShape *)maList.GetHead();
			if(pCur != NULL)
			{
				if(HAS_BASE(pCur, FOXNewTableShape))
				{
					FOXNewTableShape *pTable = (FOXNewTableShape *)(pCur);
					if(pTable != NULL)
					{
						CFOPNewTableCellList m_SelectList;
						pTable->GetSelectCells(&m_SelectList);
						
						if(m_SelectList.GetCount() >0)
						{
							CFOPSdrTableGeoAction* pAction = new CFOPSdrTableGeoAction(pModel,pTable);
							CRect rcUpdate = pTable->GetBoundRect();
							rcUpdate.bottom += 22;
							pAction->SetSaveUpdateRect(rcUpdate);
							
							POSITION pos = m_SelectList.GetHeadPosition();
							while(pos != NULL)
							{
								CFOPNewTableCell *cellX = (CFOPNewTableCell*)m_SelectList.GetNext(pos);
								if(cellX == 0) 
									continue;
								
								cellX->SetBkColor(m_crBK);
								
							}
							//	pTable->UpdateComp();
							//	InvalidateShape(pTable);
							pAction->pNewGeo = pTable->GetTableKeyData();
							if(!pModel->Do(pAction))
							{
								delete pAction;
							}
							
							return;
						}
					}
				}
			}
	}
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
		{
			if(!m_bSelect)
			{
				int nType = m_wndPattern.GetBrushControl()->GetBrushType();
				int nAct;
				m_wndTabs.GetActiveTab(nAct);
				if(nAct == 1)
				{
					nType = m_wndGradient.GetGradientControl()->GetGradientType();
					if(nType < 93)
					{
						nType = nType+42;
						
					}
					else
					{
						nType = nType;
						
					}
				}
				else if(nAct == 2)
				{
					nType = m_wndImage.GetImageTypeControl()->GetImageType();
					nType = nType + 62;
					
				}
				((CExtTabModel *)pModel)->maCurStyle.SetBkColor(m_crBK);
			//	((CExtTabModel *)pModel)->maCurStyle.SetPatternColor(m_crFG);
			//	((CExtTabModel *)pModel)->maCurStyle.SetBrushType(nType);
			}
			return;
		}
			
		if(1)//crOldBK != m_crBK || crOldFG != m_crFG)
	{
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		
		pAction->AddShapesColor(maList,m_crBK, P_ID_BK_COLOR);
	 
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
// 		
// 		m_btnFillSample.SetBKColor(m_crBK);
// 		m_btnFillSample.SetFGColor(m_crFG);
	}
}

void CUCCShapePropDlg::OnEndColourChange()
{
	// We receive this on a color change from one of the well buttons
	if(m_bSelect)
		return;

	COLORREF crOldBK = m_crBK;
	COLORREF crOldFG = m_crFG;
	m_crBK = m_wndBKColor.GetColor();
	m_crFG = m_wndFGColor.GetColor();
	
		m_wndPattern.SetFGColor(m_crFG);
		m_wndPattern.SetBKColor(m_crBK);
		m_wndGradient.SetFGColor(m_crFG);
		m_wndGradient.SetBKColor(m_crBK);

		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;

		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
		{
			if(!m_bSelect)
			{
				int nType = m_wndPattern.GetBrushControl()->GetBrushType();
				int nAct;
				m_wndTabs.GetActiveTab(nAct);
				if(nAct == 1)
				{
					nType = m_wndGradient.GetGradientControl()->GetGradientType();
					if(nType < 93)
					{
						nType = nType+42;
						
					}
					else
					{
						nType = nType;
						
					}
				}
				else if(nAct == 2)
				{
					nType = m_wndImage.GetImageTypeControl()->GetImageType();
					nType = nType + 62;
					
				}
			//	((CExtTabModel *)pModel)->maCurStyle.SetBkColor(m_crBK);
				((CExtTabModel *)pModel)->maCurStyle.SetPatternColor(m_crFG);
			//	((CExtTabModel *)pModel)->maCurStyle.SetBrushType(nType);
			}
			return;
		}
		if(1)//crOldBK != m_crBK || crOldFG != m_crFG)
		{
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		
		pAction->AddShapesColor(maList,m_crFG, P_ID_PATTERNCOLOR);
		
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
// 		
// 		m_btnFillSample.SetBKColor(m_crBK);
// 		m_btnFillSample.SetFGColor(m_crFG);
	}
}

void CUCCShapePropDlg::OnReleasedcaptureSliderTrans(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

  
void CUCCShapePropDlg::UpdateProperty(CFODrawView* pView, const BOOL &bWithAction)
{
	
	CWnd *pParent = GetParent();
	if(!pParent->IsWindowVisible())
		return;
 
	CFODataModel* pModel = pView->GetCurrentModel();
	if(NULL == pModel)
		return;

	BOOL bDoNotUpdate = FALSE;
	BOOL bDoNotUpdateCanvas = FALSE;
	CFODrawShape *pShape = NULL;
	CFODrawShapeList maList;
	GetAllSelShapes(maList);
		 
	int nCurTotal = maList.GetCount();
	if(nCurTotal > 0)
	{
		pShape = (CFODrawShape *)maList.GetHead();
	}

	if(nCurTotal == 1)
	{
		if(pShape == pOldSelect && nOldSelectCount == 1)
		{
			bDoNotUpdate = TRUE;
		}
	}

	if(nCurTotal == 0)
	{
		bDoNotUpdate = TRUE;
	}

	if(nCurTotal == 0 && nOldSelectCount == 0)
	{
		bDoNotUpdateCanvas = TRUE;
	}

	BOOL bRedrawDrawCanvas = TRUE;
	if(pOldSelect != NULL && pShape == pOldSelect && nOldSelectCount == 1)
	{
		bRedrawDrawCanvas = FALSE;
	}

	nOldSelectCount = nCurTotal;
	pOldSelect = pShape;
 
	if(NULL == pModel || FALSE == pModel->IsDesignMode())
		return;

	if(bDoNotUpdate && !bWithAction)
	{
		return;
	}

	if(pShape == NULL)
	{
		return;
	}

	m_bSelect = TRUE;
//	Use the First Shape.
	m_FontFaceName.SelectString(-1,pShape->GetFaceName());
	CString strTemp;
	strTemp.Format(_T("%u"), (short)pShape->GetPointSize());

	m_cbSize.SetWindowText(strTemp);
	m_btnTextColor.SetColor(pShape->GetFontColor());
	 
	m_crBK = pShape->GetBkColor();
	m_crFG = pShape->GetPatternColor();
	m_wndFGColor.SetColor(m_crFG);
	m_wndBKColor.SetColor(m_crBK);
	
	m_wndPattern.GetBrushControl()->SetBKColor(m_crBK);
	m_wndPattern.GetBrushControl()->SetFGColor(m_crFG);
	m_wndGradient.GetGradientControl()->SetBKColor(m_crBK);
	m_wndGradient.GetGradientControl()->SetFGColor(m_crFG);

	m_nBrushType = pShape->GetBrushType();
	int nAc = 0;
	m_wndTabs.GetActiveTab(nAc);
	if(m_nBrushType < 42)
	{
		if(nAc != 0)
			m_wndTabs.ActivateTab(0);
		
		m_wndPattern.GetBrushControl()->SetBrushType(m_nBrushType);
		
	}
	else if(m_nBrushType < 62)
	{
		if(nAc != 1)
		m_wndTabs.ActivateTab(1);
		
		m_wndGradient.GetGradientControl()->SetGradientType(m_nBrushType - 42);
		m_wndGradient.GetGradientControl()->UpdateAll();
		
	}
	else if(m_nBrushType < 92)
	{
		if(nAc != 2)
		m_wndTabs.ActivateTab(2);
		m_wndImage.GetImageTypeControl()->SetImageType(m_nBrushType - 62);
		m_wndImage.GetImageTypeControl()->UpdateAll();

		
	}
	else
	{
		if(nAc != 1)
		m_wndTabs.ActivateTab(1);
		 
		m_wndGradient.GetGradientControl()->SetGradientType(m_nBrushType);
		m_wndGradient.GetGradientControl()->UpdateAll();
	}

	m_sliderTrans.SetPos(pShape->GetTransparentValue());
 
	m_bSelect = FALSE;
}
 

void CUCCShapePropDlg::OnButtonGradient() 
{
	// TODO: Add your control notification handler code here
	
	// TODO: Add your control notification handler code here
	CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return;
	
	CFODataModel* pModel = pViewTemp->GetCurrentModel();
	if(NULL == pModel)
		return;
	
	CFODrawShapeList maList;
	GetAllSelShapes(maList);
	if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
	{
		if(!m_bSelect)
		{
			int nType = m_wndPattern.GetBrushControl()->GetBrushType();
			int nAct;
			m_wndTabs.GetActiveTab(nAct);
			if(nAct == 1)
			{
				nType = m_wndGradient.GetGradientControl()->GetGradientType();
				if(nType < 93)
				{
					nType = nType+42;
					
				}
				else
				{
					nType = nType;
					
				}
			}
			else if(nAct == 2)
			{
				nType = m_wndImage.GetImageTypeControl()->GetImageType();
				nType = nType + 62;
				
			}
		//	((CExtTabModel *)pModel)->maCurStyle.SetBkColor(m_crBK);
		//	((CExtTabModel *)pModel)->maCurStyle.SetPatternColor(m_crFG);
		//	((CExtTabModel *)pModel)->maCurStyle.SetBrushType(nType);
		}
		return;
		}
		
	CFODrawShape *pShape = (CFODrawShape *)maList.GetHead();
	FOPGradient grad;
	int nGradType = 0;
	int nGradAngle = 0;
	int nGradBorder = 0;
	int nGradCenterX = 0;
	int nGradCenterY = 0;
	
	pShape->GetPropIntValue(nGradType, P_ID_GRADIENT_TYPE);
	pShape->GetPropIntValue(nGradAngle, P_ID_GRADIENT_ANGLE);
	pShape->GetPropIntValue(nGradBorder, P_ID_GRADIENT_BORDER);
	pShape->GetPropIntValue(nGradCenterX, P_ID_GRADIENT_CENTERX);
	pShape->GetPropIntValue(nGradCenterY, P_ID_GRADIENT_CENTERY);
	
	grad.SetType((FOPGradientType)nGradType);
	grad.SetAngle((USHORT)nGradAngle);
	grad.SetBorder((USHORT)nGradBorder);
	grad.SetOfsX((USHORT)nGradCenterX);
	grad.SetOfsY((USHORT)nGradCenterY);
	 
	CFOPGradientDlg dlg;
	dlg.m_nRed = grad.GetOfsX();
	dlg.m_nGreen = grad.GetOfsY();
	dlg.m_nBright = grad.GetBorder();
	dlg.m_nAngle = grad.GetAngle() /10;
	dlg.m_crBK = m_crBK;
	dlg.m_crFG = m_crFG;
	dlg.aGradient = grad;
	if(dlg.DoModal() == IDOK)
	{
		if(grad != dlg.aGradient)
		{
			grad = dlg.aGradient;
			m_nBrushType = 110;

			CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
			CRect rc = pViewTemp->GetTotalSelectSnapRect();
			pAction->AddShapesInt(maList,m_nBrushType,P_ID_BURSHTYPE);
			pAction->AddShapesInt(maList,dlg.aGradient.GetType(), P_ID_GRADIENT_TYPE);
			pAction->AddShapesInt(maList,dlg.aGradient.GetAngle(), P_ID_GRADIENT_ANGLE);
			pAction->AddShapesInt(maList,dlg.aGradient.GetBorder(), P_ID_GRADIENT_BORDER);
			pAction->AddShapesInt(maList,dlg.aGradient.GetOfsX(), P_ID_GRADIENT_CENTERX);
			pAction->AddShapesInt(maList,dlg.aGradient.GetOfsY(), P_ID_GRADIENT_CENTERY);
			
			if(pAction->GetActionList()->GetCount() > 0)
			{
				pModel->Do(pAction, TRUE);
				pModel->SetModifiedFlag();
			}
			else
			{
				delete pAction;
			}

	 
		}
		
	}
}

LRESULT CUCCShapePropDlg::OnFillOK(WPARAM wParam, LPARAM lParam)
{
	// We receive this on a color change from one of the well buttons
	// or one of the embedded color wells.
	wParam;	
	if(m_bSelect)
		return 0L;

	m_nBrushType = m_wndPattern.GetBrushControl()->GetBrushType();
 
	int nCount = (int)lParam;
	if(nCount == 10000)
	{
	//	m_pDialog->OnEndDialog();
	}

	CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return 0L;
	
	CFODataModel* pModel = pViewTemp->GetCurrentModel();
	if(NULL == pModel)
		return 0L;
 
 
	CFODrawShapeList maList;
	GetAllSelShapes(maList);
	if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
	{
		if(!m_bSelect)
		{
			int nType = m_wndPattern.GetBrushControl()->GetBrushType();
			 
		//	((CExtTabModel *)pModel)->maCurStyle.SetBkColor(m_crBK);
		//	((CExtTabModel *)pModel)->maCurStyle.SetPatternColor(m_crFG);
		//	((CExtTabModel *)pModel)->maCurStyle.SetBrushType(nType);
		}
		return 0L;
	}
	
	
	CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
	CRect rc = pViewTemp->GetTotalSelectSnapRect();
	pAction->AddShapesInt(maList,m_nBrushType,P_ID_BURSHTYPE);
	 
	if(pAction->GetActionList()->GetCount() > 0)
	{
		pModel->Do(pAction, TRUE);
		pModel->SetModifiedFlag();
	}
	else
	{
		delete pAction;
			}
	return 0L;
}

LRESULT CUCCShapePropDlg::OnFillOK2(WPARAM wParam, LPARAM lParam)
{
	// We receive this on a color change from one of the well buttons
	// or one of the embedded color wells.
	wParam;	
	if(m_bSelect)
		return 0L;

	m_nBrushType = m_wndGradient.GetGradientControl()->GetGradientType();
	
	if(m_nBrushType < 93)
	{
		m_nBrushType = m_nBrushType+42;
		
	}
	else
	{
		m_nBrushType = m_nBrushType;
		
	}
	
	CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return 0L;
	
	CFODataModel* pModel = pViewTemp->GetCurrentModel();
	if(NULL == pModel)
		return 0L;
	 
	CFODrawShapeList maList;
	GetAllSelShapes(maList);
	if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
	{
		if(!m_bSelect)
		{
			int nType = 0; 
			{
				nType = m_wndGradient.GetGradientControl()->GetGradientType();
				if(nType < 93)
				{
					nType = nType+42;
					
				}
				else
				{
					nType = nType;
					
				}
			}
		 
		//	((CExtTabModel *)pModel)->maCurStyle.SetBkColor(m_crBK);
		//	((CExtTabModel *)pModel)->maCurStyle.SetPatternColor(m_crFG);
		//	((CExtTabModel *)pModel)->maCurStyle.SetBrushType(nType);
		}
		return 0L;
	}
	
	CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
	CRect rc = pViewTemp->GetTotalSelectSnapRect();
	pAction->AddShapesInt(maList,m_nBrushType,P_ID_BURSHTYPE);
	
	if(pAction->GetActionList()->GetCount() > 0)
	{
		pModel->Do(pAction, TRUE);
		pModel->SetModifiedFlag();
	}
	else
	{
		delete pAction;
	}
	return 0L;
}

LRESULT CUCCShapePropDlg::OnFillOK3(WPARAM wParam, LPARAM lParam)
{
	// We receive this on a color change from one of the well buttons
	// or one of the embedded color wells.
	wParam;	
	if(m_bSelect)
		return 0L;

	m_nBrushType = m_wndImage.GetImageTypeControl()->GetImageType();
	m_nBrushType = m_nBrushType + 62;
 
	CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return 0L;
	
	CFODataModel* pModel = pViewTemp->GetCurrentModel();
	if(NULL == pModel)
		return 0L;

	CFODrawShapeList maList;
	GetAllSelShapes(maList);
	if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
	{
		if(!m_bSelect)
		{
			int nType = 0; 
			{
				nType = m_wndImage.GetImageTypeControl()->GetImageType();
				nType = nType + 62;
				
			}
		//	((CExtTabModel *)pModel)->maCurStyle.SetBkColor(m_crBK);
		//	((CExtTabModel *)pModel)->maCurStyle.SetPatternColor(m_crFG);
		//	((CExtTabModel *)pModel)->maCurStyle.SetBrushType(nType);
		}
		return 0L;
	}
	
	
	CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
	CRect rc = pViewTemp->GetTotalSelectSnapRect();
	pAction->AddShapesInt(maList,m_nBrushType,P_ID_BURSHTYPE);
	
	if(pAction->GetActionList()->GetCount() > 0)
	{
		pModel->Do(pAction, TRUE);
		pModel->SetModifiedFlag();
	}
	else
	{
		delete pAction;
	}
	return 0L;
}

void CUCCShapePropDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	CSliderCtrl   *pSlidCtrl=(CSliderCtrl*)GetDlgItem(IDC_SLIDER_TRANS);
    int m_int=	pSlidCtrl->GetPos();//ȡõǰλֵ  
	CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return;
	
	CFODataModel* pModel = pViewTemp->GetCurrentModel();
	if(NULL == pModel)
		return;
	
	CFODrawShapeList maList;
	GetAllSelShapes(maList);
	if(maList.GetCount() < 1)
		return;
	
	CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
	CRect rc = pViewTemp->GetTotalSelectSnapRect();
	
	pAction->AddShapesInt(maList, m_int,P_ID_TRANSPARENTVALUE);
	 
	if(pAction->GetActionList()->GetCount() > 0)
	{
		pModel->Do(pAction, TRUE);
		pModel->SetModifiedFlag();
	}
	else
	{
		delete pAction;
		}
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

BOOL CUCCShapePropDlg::SetScrollPos32(int nBar, int nPos, BOOL bRedraw)
{
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask  = SIF_POS;
	si.nPos   = nPos;
	SetScrollInfo(nBar, &si, bRedraw);

	
	return TRUE;
}

int CUCCShapePropDlg::GetScrollPos32( int nBar, BOOL bGetTrackPos )
{
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	
	if(bGetTrackPos)
    {
		if(GetScrollInfo(nBar, &si, SIF_TRACKPOS))
			return si.nTrackPos;
    }
	else
    {
		if(GetScrollInfo(nBar, &si, SIF_POS))
			return si.nPos;
    }
	
	return 0;
}

BOOL CUCCShapePropDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
 
// 	int nMaxPos = m_rcOriginalRect.Height() - m_nCurHeight;
// 	
// 	if (zDelta<0)
// 	{
// 		if (m_nScrollPos < nMaxPos)
// 		{
// 			zDelta = min(max(nMaxPos/20,5),nMaxPos-m_nScrollPos);
// 			
// 			m_nScrollPos += zDelta;
// 			SetScrollPos(SB_VERT,m_nScrollPos,TRUE);
// 			ScrollWindow(0,-zDelta);
// 		}
// 	}
// 	else
// 	{
// 		if (m_nScrollPos > 0)
// 		{
// 			zDelta = -min(max(nMaxPos/20,5),m_nScrollPos);
// 			
// 			m_nScrollPos += zDelta;
// 			SetScrollPos(SB_VERT,m_nScrollPos,TRUE);
// 			ScrollWindow(0,-zDelta);
// 		}
// 	}
	
 
	 
	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}

void CUCCShapePropDlg::OnEditchangeComboFontsize() 
{
	// TODO: Add your control notification handler code here
	
}

BOOL CUCCShapePropDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if((pMsg->message == WM_KEYDOWN)&&(pMsg->wParam == VK_RETURN))
	{
		CWnd *pWnd = (CWnd *)GetFocus()->GetParent();
		if(pWnd->GetSafeHwnd() == m_cbSize.GetSafeHwnd())
		{
			CString strText;
			m_cbSize.GetWindowText(strText);
			 
			if(!strText.IsEmpty())
			{
				if(FOIsAllDigitsX66(strText))
				{
					int nSize = _ttoi(strText);
					if(nSize >= 0 && nSize <= 1000)
					{
						CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
						if(NULL == pViewTemp)
							return TRUE;
						
						CFODataModel* pModel = pViewTemp->GetCurrentModel();
						if(NULL == pModel)
							return TRUE;
						
						
						CFODrawShapeList maList;
						GetAllSelShapes(maList);
						if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
						{
							if(!m_bSelect)
							{
							 
								
								if(!strText.IsEmpty())
								{
									if(FOIsAllDigitsX66(strText))
									{
										int nSize = _ttoi(strText);
										((CExtTabModel *)pModel)->maCurStyle.SetPointSize(nSize);
									}
								}
								
								crText = m_btnTextColor.GetColor();
								((CExtTabModel *)pModel)->maCurStyle.SetFaceName(strText);
								
								((CExtTabModel *)pModel)->maCurStyle.SetFontColor(crText);
							}
							return  TRUE;
						}
						
						
						CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
						CRect rc = pViewTemp->GetTotalSelectSnapRect();
						pAction->AddShapesInt(maList,nSize, P_ID_FONT_POINTSIZE);
						if(pAction->GetActionList()->GetCount() > 0)
						{
							pModel->Do(pAction, TRUE);
							pModel->SetModifiedFlag();
						}
						else
						{
							delete pAction;
						}
						POSITION pos = maList.GetHeadPosition();
						while(pos != NULL)
						{
							CFODrawShape *pCur = (CFODrawShape *)maList.GetNext(pos);
							pCur->AdjustTextBoxSize(NULL);
							pCur->UpdateControl();
				}
					}
				}
			}

			return TRUE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}
