#if !defined(AFX_UCCSHAPEPROPDLG_H__0032F137_DB45_4B48_ACC0_64F2456F38C3__INCLUDED_)
#define AFX_UCCSHAPEPROPDLG_H__0032F137_DB45_4B48_ACC0_64F2456F38C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// UCCShapePropDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CUCCShapePropDlg dialog

#include "resource.h"

class CUCCShapePropDlg : public CDialog
{
// Construction
public:
	CUCCShapePropDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CUCCShapePropDlg)
	enum { IDD = IDD_DIALOG_SHAPE_PROP };
 
	CMFCButton	m_btnGradient;
	
	CSliderCtrl	m_sliderTrans;
	CMFCSpinButtonCtrl	m_spin;
 
	int		m_nTrans;
	//}}AFX_DATA

	HCURSOR m_hCursor1, m_hCursor2;
	
	// dialog size as you see in the resource view (original size)
	CRect	m_rcOriginalRect;
	
	// dragging
	BOOL	m_bDragging;
	CPoint	m_ptDragPoint;
	
	// actual scroll position
	int		m_nScrollPos;
	
	// actual dialog height
	int		m_nCurHeight;

	// Font Face Name, This member specify E-XD++ CFOFontNameCombo object.  
	CMFCFontComboBox m_FontFaceName;
 
	// Size, This member specify CComboBox object.  
	CComboBox   m_cbSize;
	// Text Color, This member specify FOPDropDownColorPickerButton object.  
	FOPDropDownColorPickerButton	m_btnTextColor;
	 
	// F G Color, This member specify FOPDropDownColorPickerButton object.  
	FOPDropDownColorPickerButton	m_wndFGColor;
	
	// B K Color, This member specify FOPDropDownColorPickerButton object.  
	FOPDropDownColorPickerButton	m_wndBKColor;
  

	// Pattern, This member specify E-XD++ CFOBrushTypeWnd object.  
	CFOBrushTypeWnd m_wndPattern;
	// Gradient, This member specify E-XD++ CFOGradientTypeWnd object.  
	CFOGradientTypeWnd m_wndGradient;
	// Image, This member specify E-XD++ CFOImageTypeWnd object.  
	CFOImageTypeWnd m_wndImage;

	BOOL m_bSelect;
	//EndArrow
	 
	// Text color.
	
	// Text, This member sets A 32-bit value used as a color value.  
	COLORREF			crText;
 
	
	// F G, This member sets A 32-bit value used as a color value.  
	COLORREF m_crFG;
	
	// Background color.
	
	// B K, This member sets A 32-bit value used as a color value.  
	COLORREF m_crBK;
	
	//Brush Type
	
	// Brush Type, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nBrushType;
	// Init font size.
	
	//Start Arrow
	CFODrawShape *pOldSelect;
	int nOldSelectCount;

	void GetAllSelShapes(CFODrawShapeList &mList);

	void EndDrag();
	
	void UpdateProperty(CFODrawView* pView, const BOOL &bWithAction = FALSE);
	
	// Get scroll position.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Scroll Pos32, Returns the specified value.
	//		Returns a int type value.  
	// Parameters:
	//		nBar---nBar, Specifies A integer value.  
	//		bGetTrackPos---Get Track Position, Specifies A Boolean value.
	int GetScrollPos32(int nBar, BOOL bGetTrackPos = FALSE );
	
	// Set scroll position.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Scroll Pos32, Sets a specify value to current class CFOToolBoxPageWnd
	//		Returns BOOLvalue, TRUE on success; FALSE otherwise.  
	// Parameters:
	//		nBar---nBar, Specifies A integer value.  
	//		nPos---nPos, Specifies A integer value.  
	//		bRedraw---bRedraw, Specifies A Boolean value.
	BOOL SetScrollPos32( int nBar, int nPos, BOOL bRedraw = TRUE );

	CFOTabCtrl			m_wndTabs;
	
	//-----------------------------------------------------------------------
	// Summary:
	// Initial Font Size, Call InitFontSize after creating a new object.
	// This member function is also a virtual function, you can Override it if you need,
	virtual void InitFontSize();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUCCShapePropDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CUCCShapePropDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeComboFontface();
	afx_msg void OnSelchangeComboFontsize();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnReleasedcaptureSliderTrans(NMHDR* pNMHDR, LRESULT* pResult);
  
	afx_msg void OnButtonGradient();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	
	afx_msg void OnEditchangeComboFontsize();
	//}}AFX_MSG
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	//-----------------------------------------------------------------------
	// Summary:
	// On Mouse Wheel, This member function is called by the framework to allow your application to handle a Windows message.
	//		Returns afx_msg BOOLvalue, TRUE on success; FALSE otherwise.  
	// Parameters:
	//		nFlags---nFlags, Specifies A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.  
	//		zDelta---zDelta, Specifies a short zDelta object(Value).  
	//		pt---Specifies A CPoint type value.
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	
	//-----------------------------------------------------------------------
	// Summary:
	// On Fill O K, This member function is called by the framework to allow your application to handle a Windows message.
	//		Returns A 32-bit LONG signed integer.  
	// Parameters:
	//		wParam---wParam, Specifies A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.  
	//		lParam---lParam, Specifies A 32-bit LONG signed integer.
	afx_msg LRESULT OnFillOK(WPARAM wParam, LPARAM lParam);
	//-----------------------------------------------------------------------
	// Summary:
	// On Fill O K, This member function is called by the framework to allow your application to handle a Windows message.
	//		Returns A 32-bit LONG signed integer.  
	// Parameters:
	//		wParam---wParam, Specifies A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.  
	//		lParam---lParam, Specifies A 32-bit LONG signed integer.
	afx_msg LRESULT OnFillOK2(WPARAM wParam, LPARAM lParam);

	//-----------------------------------------------------------------------
	// Summary:
	// On Fill O K, This member function is called by the framework to allow your application to handle a Windows message.
	//		Returns A 32-bit LONG signed integer.  
	// Parameters:
	//		wParam---wParam, Specifies A 16-bit unsigned integer on Windows versions 3.0 and 3.1; a 32-bit unsigned integer on Win32.  
	//		lParam---lParam, Specifies A 32-bit LONG signed integer.
	afx_msg LRESULT OnFillOK3(WPARAM wParam, LPARAM lParam);

	afx_msg void OnTextColourChange();
	 

	// Summary:
	// On Start Colour Change, This member function is called by the framework to allow your application to handle a Windows message.
	
	afx_msg void OnStartColourChange();
	
	//-----------------------------------------------------------------------
	// Summary:
	// On End Colour Change, This member function is called by the framework to allow your application to handle a Windows message.
	
	afx_msg void OnEndColourChange();
	 
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_UCCSHAPEPROPDLG_H__0032F137_DB45_4B48_ACC0_64F2456F38C3__INCLUDED_)
